﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class Verdeter extends Sprite
	{
		private var i:Number;
		private var o:Object;
		
		private var bmd:BitmapData;
		private var bm:Bitmap;
		
		private var tim:Timer = new Timer(20);
		
		public function Verdeter()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			this.graphics.clear();
			while(numChildren>0){
				removeChildAt(0);
			}
			addedHandler(null);
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			o = new Object();
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			bm = new Bitmap(bmd);
			bm.smoothing = true;
			addChild(bm);
			
			tim.start();
			tim.addEventListener(TimerEvent.TIMER, timerHandler);
		}
		
		private function timerHandler(event:TimerEvent):void {
			var randomNum:Number = Math.floor(Math.random() * int.MAX_VALUE);
			dissolve(randomNum);
		}
	
		private function dissolve(randomNum:Number):void {
			var rect:Rectangle = bmd.rect;
			var pt:Point = new Point(0, 0);
			var pixelNum:uint = 230;
			var red:uint = 0xff0000;
			bmd.pixelDissolve(bmd, rect, pt, randomNum, pixelNum, red);
			var grayRegion:Rectangle = bmd.getColorBoundsRect(0xffffff, 0x000000, true);
			if(grayRegion.width == 0 && grayRegion.height == 0 ) {
				tim.stop();
			}
		}
		
		private function enterHandler(e:Event):void
		{
			this.graphics.clear();
			i=0;
			while(++i<50){
				if(!o[i]){
					o[i] = [Math.random()*stage.stageWidth,Math.random()*stage.stageHeight];
				}
				this.graphics.lineStyle(0.2,Math.random()*0x000000);
				this.graphics.moveTo(o[i][0],o[i][1]);
				this.graphics.lineTo(o[i][0]+=((Math.random()-.5)*10),o[i][1]+=((Math.random()-.5)*10));
			}
			bmd.draw(this);
		}
	}
}